//+------------------------------------------------------------------+
//|                                             asymmetric bands.mq4 |
//|                                                                  |
//| forex-tsd elite section only                                     |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

#property indicator_chart_window
#property indicator_buffers  4
#property indicator_color1   clrDimGray
#property indicator_color2   clrRed
#property indicator_color3   clrLimeGreen
#property indicator_color4   clrWhite
//------
#property indicator_width1  0
#property indicator_width2  0  //3  
#property indicator_width3  0  //3  
#property indicator_width4  2  //3
//------
#property indicator_style1   STYLE_DOT

//
//
//
//
//

extern int    bandsPeriod     = 14;
extern int    bandsMethod     = MODE_SMA;
extern int    bandsPrice      = PRICE_CLOSE;
extern double bandsDeviations = 2;
extern bool   ShowMiddle      = true;
//
//
//
//
//

double maBuffer[], upBuffer[], dnBuffer[], mdBuffer[];
double wuBuffer[], wdBuffer[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
   SetIndexBuffer(0,maBuffer);   SetIndexStyle(0,DRAW_LINE);  //,STYLE_SOLID,1);
   SetIndexBuffer(1,upBuffer);   SetIndexStyle(1,DRAW_LINE);  //,STYLE_SOLID,1);
   SetIndexBuffer(2,dnBuffer);   SetIndexStyle(2,DRAW_LINE);  //,STYLE_SOLID,1);
   int MDT=ShowMiddle ? DRAW_LINE : DRAW_NONE;
   SetIndexBuffer(3,mdBuffer);   SetIndexStyle(3,MDT);  //,STYLE_SOLID,1);
   SetIndexBuffer(4,wuBuffer);
   SetIndexBuffer(5,wdBuffer);
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         
   //
   //
   //
   //
   //
            
   for(i=limit; i>=0; i--)
   {
      double price = iMA(NULL,0,1          ,0,MODE_SMA   ,bandsPrice,i);
      maBuffer[i]  = iMA(NULL,0,bandsPeriod,0,bandsMethod,bandsPrice,i);
    
         if (i==(Bars-1))
         {
            upBuffer[i] = maBuffer[i];
            dnBuffer[i] = maBuffer[i];
            wuBuffer[i] = price-maBuffer[i];
            wdBuffer[i] = price-maBuffer[i];
            continue;
         }
         
      //
      //
      //
      //
      //
      
         double diff = price-maBuffer[i];
         if(diff>=0)
            {
               wuBuffer[i] = (wuBuffer[i+1]*(bandsPeriod-1)+MathPow(diff,2))/bandsPeriod;
               wdBuffer[i] =  wdBuffer[i+1]*(bandsPeriod-1)/bandsPeriod;
            }
         else
            {
               wdBuffer[i] = (wdBuffer[i+1]*(bandsPeriod-1)+MathPow(diff,2))/bandsPeriod;
               wuBuffer[i] =  wuBuffer[i+1]*(bandsPeriod-1)/bandsPeriod;
            }
         upBuffer[i] = maBuffer[i] + bandsDeviations*MathSqrt(wuBuffer[i]);
         dnBuffer[i] = maBuffer[i] - bandsDeviations*MathSqrt(wdBuffer[i]);
         mdBuffer[i] = (upBuffer[i]+dnBuffer[i]) /2;
   }
   return(0);
}

